<?php
/**
 * webEdition CMS
 *
 * $Rev: 2b2dbb70cc3f $
 * $Author: Lukas Imhof $
 * $Date: 2019-02-18 22:51 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
define('NO_SESS', 1);
require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we.inc.php');
header('Content-type: text/css');
header('Expires: ' . gmdate('D, d M Y H:i:s', time() + we_base_util::SECONDS_DAY) . ' GMT', true);
header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime(__FILE__)) . ' GMT', true);
header('Cache-Control: max-age=' . we_base_util::SECONDS_DAY . ', must-revalidate', true);
header('Pragma: ', true);
?>

/* css editor body:font-size: this sheet is included first, for font-size to be eventually overwritten by document-css */

body {
font-size: 12px;
<?php
$bgcolor = we_base_request::_(we_base_request::STRING, 'tinyMceBackgroundColor');
$bgcolor = preg_match('/^[a-f0-9]{6}$/i', $bgcolor) ? '#' . $bgcolor : $bgcolor;
echo $bgcolor ? '
background-color: ' . $bgcolor . ' !important;
background-image: none !important;
' : '';
?>
}

html{
	height: 100%;
}
body{
	height: calc(100% - 20px);
}

/* css for plugin wevisialborders */

acronym.mceItemWeAcronym{
border: 1px dotted gray;
}

abbr.mceItemWeAbbr{
border: 1px dotted gray;
}

span.mceItemWeLang{
border: 1px dotted gray;
}


we-gallery{
display: block;
font-size: 14px;
}

we-gallery:before {
font-family: FontAwesome;
content: "\f187 ";
color: #164F94;
}

we-gallery:after {
font-family: Helvetica;
content: "<?= g_l('contentTypes', '[text/weCollection]'); ?>";
color: #164F94;
border: 1px dotted gray;
}
