/* global WE, top, LinkDialog, ImageDialog */

/**
 * webEdition SDK
 *
 * webEdition CMS
 * $Rev: 342e215a2edb $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-03-21 11:07 +0000 $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 * @category   we
 * @subpackage we_ui_layout
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
'use strict';
var payload = WE().util.getDynamicVar(document, 'loadVarDialog_cmdFrame', 'data-payload');
var isWeDialog = true;

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window);
	var args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments));
	//var url = WE().util.getWe_cmdArgsUrl(args);

	switch (args[0]) {
		case 'update_dialog_image':
			top.update_dialog(payload);
			break;
		case 'image_writeback':
			top.ImageDialog.writeBack(payload.attributes);
			break;
		case 'link_writeback':
			top.LinkDialog.writeBack(payload.attributes);
			break;
		case 'fullscreen_writeback': // FIXME: why don't we use this for inlineedit=false too?
			top.WefullscreenDialog.writeBack();
			break;
		case 'wysiwyg_writeBack':
			// FIXME: why do we write back to visble frame instead of opener?
			var openerDoc = payload.isFrontendEdit ? top.opener.document : WE().layout.weEditorFrameController.getVisibleEditorFrame().document;
			try {
				openerDoc.getElementById(payload.name).value = payload.textareaValue;
			} catch (err) {
				WE().t_e('we_cmd "wysiwyg_writeBack": could not write back to textarea', err);
			}
			try {
				openerDoc.getElementById('div_wysiwyg_' + payload.name).innerHTML = payload.divValue;
			} catch (err) {
				WE().t_e('we_cmd "wysiwyg_writeBack": could not write back to preview div', err);
			}
			try {
				WE().layout.weEditorFrameController.getVisibleEditorFrame().seeMode_dealWithLinks();
			} catch (err) {}

			top.close();
			break;
		default:
			top.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
	}
}
