<?php
/**
 * Simple interface for creating OASIS OpenDocument files.
 *
 */

/**
 * Simplfied OpenDocument creator class
 *
 */
class we_exim_ExportOpenDocument{
	const NS = <<<EOT
xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
EOT;
	const MIME = <<<EOT
<?xml version="1.0" encoding="UTF-8"?>
<manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0">
<manifest:file-entry manifest:media-type="REPLACE_MIME" manifest:full-path="/"/>
<manifest:file-entry manifest:media-type="text/xml" manifest:full-path="content.xml"/>
<manifest:file-entry manifest:media-type="text/xml" manifest:full-path="meta.xml"/>
<manifest:file-entry manifest:media-type="text/xml" manifest:full-path="styles.xml"/>
</manifest:manifest>
EOT;
	/* const STYLE = <<<EOT
	  <?xml version="1.0" encoding="UTF-8"?>
	  <office:document-styles REPLACE_NS office:version="1.0">
	  <office:font-face-decls>
	  <style:font-face style:name="Arial Unicode MS" svg:font-family="'Arial Unicode MS'" style:font-pitch="variable"/>
	  <style:font-face style:name="DejaVu Sans1" svg:font-family="'DejaVu Sans'" style:font-pitch="variable"/>
	  <style:font-face style:name="HG Mincho Light J" svg:font-family="'HG Mincho Light J'" style:font-pitch="variable"/>
	  <style:font-face style:name="DejaVu Serif" svg:font-family="'DejaVu Serif'" style:font-family-generic="roman" style:font-pitch="variable"/>
	  <style:font-face style:name="Thorndale" svg:font-family="Thorndale" style:font-family-generic="roman" style:font-pitch="variable"/>
	  <style:font-face style:name="DejaVu Sans" svg:font-family="'DejaVu Sans'" style:font-family-generic="swiss" style:font-pitch="variable"/>
	  </office:font-face-decls>
	  <office:styles>
	  <style:default-style style:family="paragraph">
	  <style:paragraph-properties fo:hyphenation-ladder-count="no-limit" style:text-autospace="ideograph-alpha" style:punctuation-wrap="hanging" style:line-break="strict" style:tab-stop-distance="0.4925in" style:writing-mode="page"/>
	  <style:text-properties style:use-window-font-color="true" style:font-name="DejaVu Serif" fo:font-size="12pt" fo:language="en" fo:country="US" style:font-name-asian="DejaVu Sans1" style:font-size-asian="12pt" style:language-asian="none" style:country-asian="none" style:font-name-complex="DejaVu Sans1" style:font-size-complex="12pt" style:language-complex="none" style:country-complex="none" fo:hyphenate="false" fo:hyphenation-remain-char-count="2" fo:hyphenation-push-char-count="2"/>
	  </style:default-style>
	  <style:style style:name="Standard" style:family="paragraph" style:class="text"/>
	  <style:style style:name="Text_body" style:display-name="Text body" style:family="paragraph" style:parent-style-name="Standard" style:class="text">
	  <style:paragraph-properties fo:margin-top="0in" fo:margin-bottom="0.0835in"/>
	  </style:style>
	  <style:style style:name="Heading" style:family="paragraph" style:parent-style-name="Standard" style:next-style-name="Text_body" style:class="text">
	  <style:paragraph-properties fo:margin-top="0.1665in" fo:margin-bottom="0.0835in" fo:keep-with-next="always"/>
	  <style:text-properties style:font-name="DejaVu Sans" fo:font-size="14pt" style:font-name-asian="DejaVu Sans1" style:font-size-asian="14pt" style:font-name-complex="DejaVu Sans1" style:font-size-complex="14pt"/>
	  </style:style>
	  <style:style style:name="Heading_1" style:display-name="Heading 1" style:family="paragraph" style:parent-style-name="Heading" style:next-style-name="Text_body" style:class="text" style:default-outline-level="1">
	  <style:text-properties style:font-name="Thorndale" fo:font-size="24pt" fo:font-weight="bold" style:font-name-asian="HG Mincho Light J" style:font-size-asian="24pt" style:font-weight-asian="bold" style:font-name-complex="Arial Unicode MS" style:font-size-complex="24pt" style:font-weight-complex="bold"/>
	  </style:style>
	  <style:style style:name="Heading_2" style:display-name="Heading 2" style:family="paragraph" style:parent-style-name="Heading" style:next-style-name="Text_body" style:class="text" style:default-outline-level="2">
	  <style:text-properties style:font-name="DejaVu Serif" fo:font-size="18pt" fo:font-weight="bold" style:font-name-asian="DejaVu Sans1" style:font-size-asian="18pt" style:font-weight-asian="bold" style:font-name-complex="DejaVu Sans1" style:font-size-complex="18pt" style:font-weight-complex="bold"/>
	  </style:style>
	  </office:styles>
	  </office:document-styles>
	  EOT;

	  <office:automatic-styles>
	  <style:page-layout style:name="pm1">
	  <style:page-layout-properties fo:page-width="8.2673in" fo:page-height="11.6925in" style:num-format="1" style:print-orientation="portrait" fo:margin-top="1in" fo:margin-bottom="1in" fo:margin-left="1.25in" fo:margin-right="1.25in" style:writing-mode="lr-tb" style:footnote-max-height="0in">
	  <style:footnote-sep style:width="0.0071in" style:distance-before-sep="0.0398in" style:distance-after-sep="0.0398in" style:adjustment="left" style:rel-width="25%" style:color="#000000"/>
	  </style:page-layout-properties>
	  <style:header-style/>
	  <style:footer-style/>
	  </style:page-layout>
	  </office:automatic-styles>

	  <office:master-styles>
	  <style:master-page style:name="Standard" style:page-layout-name="pm1"/>
	  </office:master-styles>
	 */
	const META = <<<EOT
<?xml version="1.0" encoding="UTF-8"?>
	<office:document-meta xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" office:version="1.0">
	<office:meta>
		<meta:generator>REPLACE_CREATOR</meta:generator>
		<meta:initial-creator>REPLACE_CREATOR</meta:initial-creator>
		<meta:creation-date>REPLACE_TIME</meta:creation-date>
	</office:meta>
</office:document-meta>
EOT;
	const ODS_HEADER = <<<EOT
<?xml version="1.0" encoding="utf-8"?>
	<office:document-content REPLACE_NS office:version="1.0">
	<office:automatic-styles>
		<number:date-style style:name="N37" number:automatic-order="true">
			<number:month number:style="long"/>
			<number:text>/</number:text>
			<number:day number:style="long"/>
			<number:text>/</number:text>
			<number:year/>
		</number:date-style>
		<number:time-style style:name="N43">
			<number:hours number:style="long"/>
			<number:text>:</number:text>
			<number:minutes number:style="long"/>
			<number:text>:</number:text>
			<number:seconds number:style="long"/>
			<number:text> </number:text>
			<number:am-pm/>
		</number:time-style>
		<number:date-style style:name="N50" number:automatic-order="true" number:format-source="language">
			<number:month/>
			<number:text>/</number:text>
			<number:day/>
			<number:text>/</number:text>
			<number:year/>
			<number:text> </number:text>
			<number:hours number:style="long"/>
			<number:text>:</number:text>
			<number:minutes number:style="long"/>
			<number:text> </number:text>
			<number:am-pm/>
		</number:date-style>
		<style:style style:name="DateCell" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="N37"/>
		<style:style style:name="TimeCell" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="N43"/>
		<style:style style:name="DateTimeCell" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="N50"/>
		<style:style style:name="ce1" style:family="table-cell" style:parent-style-name="Default"><style:text-properties fo:font-weight="bold" style:font-weight-asian="bold" style:font-weight-complex="bold"/></style:style>
	</office:automatic-styles>
	<office:body>
		<office:spreadsheet>
EOT;
	const ODS_FOOTER = <<<EOT
		</office:spreadsheet>
	</office:body>
</office:document-content>
EOT;
	const ODS_MIME = 'application/vnd.oasis.opendocument.spreadsheet';

	/** @var array<string,string> */
	private $tables = [];

	/**
	 * Minimalistic creator of OASIS OpenDocument
	 *
	 * @param string $mime desired MIME type
	 * @param string $data document content
	 *
	 * @return string  OASIS OpenDocument data
	 *
	 * @access  public
	 */
	private function create(string $file): void{
		$zip = new ZipArchive();
		$zip->open($file, ZIPARCHIVE::OVERWRITE);
		$zip->addFromString('mimetype', self::ODS_MIME);
		$zip->addFromString('content.xml',
											strtr(self::ODS_HEADER, ['REPLACE_NS' => self::NS]) .
			$this->getContent() .
			strtr(self::ODS_FOOTER, ['REPLACE_NS' => self::NS]));
		$zip->addFromString('meta.xml', strtr(self::META, ['REPLACE_CREATOR' => 'webEdition ' . WE_VERSION, 'REPLACE_TIME' => strftime('%Y-%m-%dT%H:%M:%S')]));
		//$zip->addFromString('styles.xml', strtr(self::STYLE, ['REPLACE_NS' => self::NS]));
		$zip->addFromString('META-INF/manifest.xml', strtr(self::MIME, ['REPLACE_MIME' => self::ODS_MIME]));
		$zip->close();
	}

	private function createTemp(string $outPutFilename): void{
		$tmpFile = we_base_file::saveTemp(' ');
		self::create($tmpFile);
		header('Content-Type: ' . self::ODS_MIME, true);
		header('Pragma: public');
		header('Expires: 0');
		header('Cache-control: private, max-age=0, must-revalidate');
		header('Content-Disposition: attachment; filename="' . trim(htmlentities(basename($outPutFilename))) . '"');
		header('Content-Description: ' . trim(htmlentities(basename($outPutFilename))));
		header('Content-Length: ' . filesize($tmpFile));
		readfile($tmpFile);
		we_base_file::delete($tmpFile);
	}

	private function getContent(): string{
		$ret = '';
		foreach($this->tables as $name => $data){
			$ret .= '<table:table table:name="' . htmlspecialchars($name) . '">
	' . $data . '
</table:table>';
			unset($this->tables[$name]);
		}
		return $ret;
	}

	private function addTable(string $tab){
		$this->tables[$tab] = '';
	}

	private function addRow(string $tab, string $row){
		$this->tables[$tab] .= '<table:table-row>
	' . $row . '
</table:table-row>';
	}

	private static function addCell(string $type, $val): string{
		switch($type){
			case we_database_base::TYPE_NULL:
				$val = '';
			default:
			case we_database_base::TYPE_SHORT_STRING:
				return '<table:table-cell office:value-type="string"><text:p>' . htmlspecialchars(stripslashes(mb_convert_encoding($val, 'UTF-8', 'ISO-8859-15,UTF-8'))) . '</text:p></table:table-cell>';
			case 'header':
				return '<table:table-cell table:style-name="ce1"  office:value-type="string"><text:p>' . htmlspecialchars(stripslashes(mb_convert_encoding($val, 'UTF-8', 'ISO-8859-15,UTF-8'))) . '</text:p></table:table-cell>';
			case we_database_base::TYPE_SHORT_NUMBER:
				return '<table:table-cell office:value-type="float" office:value="' . $val . '"><text:p>' . strval($val) . '</text:p></table:table-cell>';
			case we_database_base::TYPE_SHORT_DATE:
				return '<table:table-cell office:value-type="date" office:date-value="' . date('Y-m-d\TH:i:s', strtotime($val)) . '" table:style-name="DateTimeCell"><text:p>' . ($val) . '</text:p></table:table-cell>';
		}
	}

	public static function exportSpreadSheet(array $tabQuery, string $filename, array $skipFields = [], $union = false): void{
		$db = new DB_WE();
		$ods = new self();
		$content = false;
		foreach($tabQuery as $tableName => $query){
			$tableName = mb_convert_encoding($tableName, 'UTF-8', 'ISO-8859-15,UTF-8');
			$db->query($query, $union, true);

			$ods->addTable($tableName);

			$header = $db->fieldNames();
			if(empty($header)){
				continue;
			}
			$content = true;
			$row = '';
			$fieldTypes = [];
			foreach($header as $pos => $name){
				if(in_array($name, $skipFields)){
					continue;
				}
				$row .= self::addCell('header', $name) . "\n";
				$fieldTypes[$name] = $db->field_type_short($pos);
			}
			$ods->addRow($tableName, $row);
			while($db->next_record()){
				$row = '';
				foreach($db->getRecord() as $name => $val){
					if(in_array($name, $skipFields)){
						continue;
					}
					$row .= self::addCell($fieldTypes[$name], $val) . "\n";
				}
				$ods->addRow($tableName, $row);
			}
		}
		if(!$content){
			throw new Exception('no content');
		}
		$ods->createTemp($filename);
	}

}
