<?php

/**
 * webEdition CMS
 *
 * $Rev: 3b2f6882793a $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-27 16:57 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_tagData_linkAttribute extends we_tagData_attribute{

	/**
	 * @param string $name
	 * @param boolean $required
	 */
	function __construct($name, $required = false, $module = '', $value = '', $description = '', $deprecated = false){
		parent::__construct($name, $required, $module, $description, $deprecated);
		$this->Value = $value;
	}

	/**
	 * @return string
	 */
	function getCodeForTagWizard(){
		return '<table class="attribute"><tr>
						<td class="attributeName defaultfont">&nbsp;</td><td class="attributeField">' .
			we_html_element::span(['name' => $this->Name,
				'id' => $this->getIdName(),
				'value' => '',
				'class' => 'defaultfont'
				], '<a href="http://' . $this->Value . '" target="TagRef">' . g_l('taged', '[tagreference_linktext]') . '</a>') . '</td>
					</tr></table>';
	}

}

//FIXME: remove
class weTagData_linkAttribute extends we_tagData_linkAttribute{

	public function __construct($name, $required = false, $module = '', $value = '', $description = '', $deprecated = false){

		t_e('deprecated', 'this class is removed in 8.1');
		parent::__construct($name, $required, $module, $value, $description, $deprecated);
	}

}
