<?php

/**
 * webEdition CMS
 *
 * $Rev: 3b2f6882793a $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-27 16:57 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_tagData_selectorAttribute extends we_tagData_attribute{
	const FOLDER = 'folder';

	/**
	 * @var string
	 */
	protected $Table;

	/**
	 * @var string
	 */
	protected $Selectable;
	private $useName;

	/**
	 * @param string $name
	 * @param string $table
	 * @param string $selectable
	 * @param boolean $required
	 */
	function __construct($name, $table, $selectable, $required = false, $module = '', $useName = false, $description = '', $deprecated = false){
		parent::__construct($name, $required, $module, $description, $deprecated);
		$this->Table = $table;
		$this->Selectable = $selectable;
		$this->useName = $useName;
	}

	/**
	 * @return string
	 */
	function getCodeForTagWizard(){
		switch($this->Table){
			case CATEGORY_TABLE:
				$weCmd = 'we_selector_document';
				$this->Selectable = '';
				break;
			case NAVIGATION_TABLE:
				$weCmd = 'we_selector_file';
				break;
			default:
				$weCmd = ($this->Selectable == self::FOLDER ? 'we_selector_directory' : 'we_selector_document');
		}

		$input = we_html_element::input([
				'name' => $this->Name,
				'value' => $this->Value,
				'id' => $this->getIdName(),
				'class' => 'wetextinput'
		]);
		$button = we_html_button::create_button(we_html_button::SELECT, "javascript:we_cmd('" . $weCmd . "', document.getElementById('" . $this->getIdName() . "').value, '" . $this->Table . "', '" . ($this->useName ? '' : $this->getIdName()) . "', '" . ($this->useName ? $this->getIdName() : '') . "', '', '', '', '" . $this->Selectable . "')");

		return '<table class="attribute"><tr>
						<td class="attributeName">' . $this->getLabelCodeForTagWizard() . '</td>
						<td class="attributeField">' . $input . '</td>
						<td class="attributeButton">' . $button . '</td>
					</tr></table>';
	}

}

//FIXME: remove
class weTagData_selectorAttribute extends we_tagData_selectorAttribute{

	public function __construct($name, $table, $selectable, $required = false, $module = '', $useName = false, $description = '', $deprecated = false){
		t_e('deprecated', 'this class is removed in 8.1');
		parent::__construct($name, $table, $selectable, $required, $module, $useName, $description, $deprecated);
	}

}
