<?php

/**
 * webEdition CMS
 *
 * $Rev: 17f94d5788df $
 * $Author: mokraemer $
 * $Date: 2019-01-09 10:59 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_users_changePassword{

	private static function getContent(){
		$auth = new PHPGangsta_GoogleAuthenticator();

		return '
		<form action="' . $_SERVER['REQUEST_URI'] . '" method="post">' .
			we_html_tools::dialogLayout('
						<table class="default">
							<tr><td class="defaultfont">' . g_l('global', '[oldPass]') . '</td></tr>
							<tr><td style="padding-bottom:5px;">' . we_html_tools::textInput('oldpasswd', '', 32, [], 'password', 200) . '</td></tr>
							<tr><td>' . we_html_tools::alertAttentionBox(SECURITY_USER_PASS_DESC, we_html_tools::TYPE_INFO) . '</td></tr>
							<tr><td class="defaultfont">' . g_l('global', '[newPass]') . '</td></tr>
							<tr><td style="padding-bottom:5x;"><div id="badPwd" style="display:none;" class="arrow_box">' . g_l('global', '[pass_to_short]') . '</div>' . we_html_tools::textInput('newpasswd', '', 32, [
					'onchange' => "setPwdErr(comparePwd('newpasswd','newpasswd2'));"], 'password', 200) . '</td></tr>
							<tr><td class="defaultfont"><div id="badPwd2" style="display:none;" class="arrow_box">' . g_l('global', '[pass_not_confirmed]') . '</div>' . g_l('global', '[newPass2]') . '</td></tr>
							<tr><td>' . we_html_tools::textInput('newpasswd2', '', 32, ['onchange' => "setPwdErr(comparePwd('newpasswd','newpasswd2'));"], 'password', 200) . '</td></tr>
								<tr><td style="padding-top:2ex;">' . g_l('modules_users', '[TOTP]') . we_html_element::br() . we_html_tools::textInput('TOTP', '', 32, ['pattern' => '[A-Za-z2-7=]{16,128}',
					'id' => 'totp'], 'text', 160) . '<input id="newSecretTOTP" type="hidden" name="_none" value="' . $auth->createSecret() . '" />' . we_html_button::create_button(we_html_button::RELOAD, '', '', "document.getElementById('totp').value=document.getElementById('newSecretTOTP').value;") . '</td></tr>
							<tr><td>' . g_l('modules_users', '[TOTP_Key]') . we_html_element::br() . we_html_tools::textInput('TOTP_Token', '', 0, ['placeholder' => '123456', 'pattern' => '[0-9]{6,}'], 'text', 200) . '</td></tr>
						</table>', g_l('global', '[changePass]'), we_html_button::position_yes_no_cancel(we_html_button::create_button(we_html_button::SAVE, 'javascript:document.forms[0].submit();'), '', we_html_button::create_button(we_html_button::CANCEL, 'javascript:top.close();'))
			) . we_html_element::hidden('cmd', 'ok') . '</form>';
	}

	private static function getLoad(we_base_jsCmd $jsCmd){
		$DB_WE = $GLOBALS['DB_WE'];
		$oldpasswd = we_base_request::_(we_base_request::RAW_CHECKED, 'oldpasswd', '');
		$newpasswd = we_base_request::_(we_base_request::RAW_CHECKED, 'newpasswd', '');
		$newpasswd2 = we_base_request::_(we_base_request::RAW_CHECKED, 'newpasswd2', '');
		$totp_secret = we_base_request::_(we_base_request::RAW_CHECKED, 'TOTP');
		$totp_token = we_base_request::_(we_base_request::RAW_CHECKED, 'TOTP_Token');

		$auth = new PHPGangsta_GoogleAuthenticator();

		if(we_base_request::_(we_base_request::STRING, 'cmd') === 'ok'){
			$userData = f('SELECT passwd FROM ' . USER_TABLE . ' WHERE username="' . $DB_WE->escape($_SESSION['user']['Username']) . '"');

			if(!we_users_user::comparePasswords($_SESSION['user']['Username'], $userData, $oldpasswd)){
				$jsCmd->addMsg(g_l('global', '[pass_not_match]'), we_base_util::WE_MESSAGE_ERROR);
			} elseif(!preg_match('/' . addcslashes(SECURITY_USER_PASS_REGEX, '/') . '/', $newpasswd)){
				$jsCmd->addMsg(g_l('global', '[pass_to_short]'), we_base_util::WE_MESSAGE_ERROR);
			} elseif($newpasswd != $newpasswd2){
				$jsCmd->addMsg(g_l('global', '[pass_not_confirmed]'), we_base_util::WE_MESSAGE_ERROR);
			} elseif($totp_secret && (!$totp_token || !$auth->verifyCode($totp_secret, $totp_token, 2))){
				$jsCmd->addMsg(g_l('modules_users', '[totp_secret_error]'), we_base_util::WE_MESSAGE_ERROR);
			} else {
				$set = [
					'passwd' => we_users_user::makeSaltedPassword($newpasswd),
				];
				if($totp_secret){//new totp
					$set['TOTP'] = $totp_secret;
				}
				$DB_WE->query('UPDATE ' . USER_TABLE . ' SET ' . we_database_base::arraySetter($set) . ' WHERE ID=' . $_SESSION['user']['ID'] . ' AND username="' . $DB_WE->escape($_SESSION['user']['Username']) . '"');
				$jsCmd->addMsg(g_l('global', '[pass_changed]'), we_base_util::WE_MESSAGE_NOTICE);
				$jsCmd->addCmd('close');
				return;
			}
		}
		return;
	}

	public static function showDialog(){
		$jsCmd = new we_base_jsCmd();
		self::getLoad($jsCmd);
		echo we_html_tools::getHtmlTop(g_l('global', '[changePass]'), '', '', we_html_element::jsScript(JS_DIR . 'comparePwd.js', '', ['id' => 'loadVarComparePwd', 'data-passwd' => setDynamicVar([
					'pwdCheck' => SECURITY_USER_PASS_REGEX
			])]) . $jsCmd->getCmds(), we_html_element::body(['class' => 'weDialogBody', 'onload' => 'self.focus();'], we_html_element::exIFrame('passwdcontent', self::getContent(), 'position:absolute;top:0;bottom:1px;left:0;right:0;')
		));
	}

}
