<?php

/**
 * webEdition CMS
 *
 * $Rev: cda12c96a4a3 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-27 13:04 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_bannerSelect extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}

		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$customer = self::getAttribute('customer', $attribs, false, we_base_request::BOOL);
		//$rootdir = self::getAttribute('rootdir', $attribs, '/');
		$firstentry = self::getAttribute('firstentry', $attribs, '', we_base_request::STRING);
		$showpath = self::getAttribute('showpath', $attribs, false, we_base_request::BOOL);
		$submitonchange = self::getAttribute('submitonchange', $attribs, false, we_base_request::BOOL);

		$newAttribs = removeAttribs($attribs, ['showpath', 'rootdir', 'firstentry', 'submitonchange', 'customer']);
		if($submitonchange){
			$newAttribs['onchange'] = 'we_submitForm();';
		}

		$options = ($firstentry ? getHtmlTag('option', ['value' => ''], $firstentry, true) : '');

		$GLOBALS['DB_WE']->query('SELECT ID,Text,Path,Customers FROM ' . BANNER_TABLE . '  WHERE IsFolder=0 ORDER BY Path');
		$res = $GLOBALS['DB_WE']->getAll();
		foreach($res as $record){
			if((!we_modules_info::isActive(we_modules_info::CUSTOMER)) || (!$customer) || ($customer && we_modules_info::isActive(we_modules_info::CUSTOMER) && !empty($_SESSION['webuser']['registered']) &&
				we_banner_banner::customerOwnsBanner($_SESSION['webuser']['ID'], $record['ID'], $GLOBALS['DB_WE']))){
				$rName = we_base_request::_(we_base_request::HTML, $name, $record['Path']);
				$options .= ($rName == $record['Path'] ?
					getHtmlTag('option', ['value' => $record['Path'], 'selected' => 'selected'], $showpath ? $record['Path'] : $record['Text']) :
					getHtmlTag('option', ['value' => $record['Path']], $showpath ? $record['Path'] : $record['Text']));
			}
		}

		if(isset($_REQUEST[$name])){
			$GLOBALS[$name] = we_base_request::_(we_base_request::FILE, $name);
		}
		return getHtmlTag('select', $newAttribs, $options, true);
	}

}

function we_tag_bannerSelect(array $attribs){
	return we_tag_bannerSelect::tag($attribs);
}
