<?php

/**
 * webEdition CMS
 *
 * $Rev$
 * $Author$
 * $Date$
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifClient extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){

		$br = we_base_browserDetect::inst();

		if(($browser = self::getAttribute('browser', $attribs, '', we_base_request::STRING))){
			$bro = explode(',', $browser);
			$browserOfClient = $br->getBrowser();
			$browserMatched = in_array($browserOfClient, $bro);
			// for backwards compatibility
			if(!$browserMatched){
				$browserMatched = ((we_base_browserDetect::isNN() && in_array('mozilla', $bro)) ||
					($browserOfClient == we_base_browserDetect::APPLE && in_array('safari', $bro)));
			}
			if(!$browserMatched){
				return false;
			}
		} else {
			$browserMatched = true;
		}

		if(($version = self::getAttribute('version', $attribs, '', we_base_request::FLOAT))){
			$brv = $br->getBrowserVersion();
			switch(self::getAttribute('operator', $attribs, '', we_base_request::STRING)){
				case 'equal':
					$versionMatched = (floor(floatval($brv)) == floor($version));
					break;
				case 'less':
					$versionMatched = (floatval($brv) < $version);
					break;
				case 'less|equal':
					$versionMatched = (floatval($brv) <= $version);
					break;
				case 'greater':
					$versionMatched = (floatval($brv) > $version);
					break;
				case 'greater|equal':
					$versionMatched = (floatval($brv) >= $version);
					break;
				default:
					$versionMatched = false;
					break;
			}
			if(!$versionMatched){
				return false;
			}
		} else {
			$versionMatched = true;
		}

		$system = self::getAttribute('system', $attribs, '', we_base_request::STRING);

		$systemMatched = ($system && $browserMatched && $versionMatched ? in_array($br->getSystem(), explode(',', $system)) : true);

		return $browserMatched && $versionMatched && $systemMatched;
	}

}

function we_tag_ifClient(array $attribs){
	return we_tag_ifClient::tag($attribs);
}
