<?php

/**
 * webEdition CMS
 *
 * $Rev: da15b82d2d13 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-10-01 23:23 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_sum extends we_weTag_tag{
	private static $sum = [];

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}
		$name = self::getAttribute('_name_orig', $attribs, '', we_base_request::STRING);
		$result = (isset(self::$sum[$name]) ? we_base_util::std_numberformat(self::$sum[$name]) : 0);

		return we_base_util::formatNumber($result, self::getAttribute('num_format', $attribs, '', we_base_request::STRING), self::getAttribute('decimals', $attribs, 2, we_base_request::INT));
	}

	public static function getSum($name){
		return isset(self::$sum[$name]) ? self::$sum[$name] : false;
	}

	public static function addSum($name, $value){
		if(!isset(self::$sum[$name])){
			self::$sum[$name] = 0;
		}
		self::$sum[$name] += $value;
	}

}

function we_tag_sum(array $attribs){
	return we_tag_sum::tag($attribs);
}
