<?php

/**
 * webEdition CMS
 *
 * $Rev: 94dc0535504a $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-27 23:01 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_voting extends we_weTag_tag{
	public static $namespace = '';
	public static $currentVoting = null;

	public static function parse(array $attribs, $content){
		return '<?php ' . we_weTag_parser::printTag('voting', $attribs) . ';?>' . $content . '<?php ' . we_weTag_parser::printTag('condition', ['_type' => 'stop']) . ';?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!we_modules_info::isActive(we_modules_info::VOTING)){
			return self::modulMissingError('Voting', __CLASS__);
		}
		if(self::getAttribute('_type', $attribs, '', we_base_request::STRING) === 'stop'){
			self::$namespace = '';
			self::$currentVoting = null;
			return;
		}
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			return $foo;
		}

		$id = self::getAttribute('id', $attribs, 0, we_base_request::INT);
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$version = self::getAttribute('version', $attribs, 0, we_base_request::INT);

		self::$namespace = $name;

		if($GLOBALS['we_doc']->issetElement($name)){
			self::$currentVoting = new we_voting_voting($GLOBALS['we_doc']->getElement($name));
		} else if($id != 0){
			self::$currentVoting = new we_voting_voting($id);
		} else {
			$voting_matches = [];
			self::$currentVoting = (preg_match_all('/_we_voting_answer_([0-9]+)_?([0-9]+)?/', implode(',', array_keys($_REQUEST)), $voting_matches) ?
				new we_voting_voting($voting_matches[1][0]) :
				new we_voting_voting());
		}

		self::$currentVoting->setDefVersion(max( --$version, 0));
		return '';
	}

}

function we_tag_voting(array $attribs){
	return we_tag_voting::tag($attribs);
}
