<?php

/**
 * webEdition CMS
 *
 * $Rev: 26e2f77c0682 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-07-18 12:01 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_widget_upb extends we_widget_base{

	private $ct = '';
	private $bTypeDoc = false;
	private $bTypeObj = false;

	public function __construct($curID = '', $aProps = []){
		$aProps = $aProps ? $aProps : [
			0,
			0,
			0,
			we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0)
		];

// widget UNPUBLISHED
		$this->bTypeDoc = (bool) $aProps[3]{0};
		$this->bTypeObj = (bool) $aProps[3]{1};
		$objectFilesTable = OBJECT_FILES_TABLE;
		$numRows = 25;

		$tbls = [];
		if($this->bTypeDoc && $this->bTypeObj){
			$tbls[] = FILE_TABLE;
			if(we_modules_info::isActive(we_modules_info::OBJECT) && we_base_permission::hasPerm(we_base_perm::OBJECTFILES_CAN_SEE)){
				$tbls[] = OBJECT_FILES_TABLE;
			}
		} else {
			if($this->bTypeDoc){
				$tbls[] = FILE_TABLE;
			}
			if($this->bTypeObj && we_modules_info::isActive(we_modules_info::OBJECT) && we_base_permission::hasPerm(we_base_perm::OBJECTFILES_CAN_SEE)){
				$tbls[] = OBJECT_FILES_TABLE;
			}
		}

		$cont = [];
		$db = $GLOBALS['DB_WE'];
		foreach($tbls as $table){
			if(we_modules_info::isActive(we_modules_info::WORKFLOW)){
				$myWfDocsArray = we_workflow_utility::getWorkflowDocsForUser($_SESSION['user']['ID'], $table, we_base_permission::hasPerm(we_base_perm::ADMINISTRATOR), we_base_permission::hasPerm(we_base_perm::WORK_CAN_PUBLISH), ($table == $objectFilesTable) ? '' : get_ws($table));
				$myWfDocsCSV = implode(',', $myWfDocsArray);
				$wfDocsArray = we_workflow_utility::getAllWorkflowDocs($table);
				$wfDocsCSV = implode(',', $wfDocsArray);
			} else {
				$wfDocsCSV = $myWfDocsCSV = '';
			}

			$offset = we_base_request::_(we_base_request::INT, 'offset', 0);
			$order = we_base_request::_(we_base_request::STRING, 'order', "ModDate DESC");

			//get workspace query


			$parents = $childs = [];
			$parentlist = $childlist = '';

			if($table === FILE_TABLE){
				if(($wsArr = get_ws($table, true))){
					foreach($wsArr as $i){
						$parents[] = $i;
						$childs[] = $i;
						we_readParents($i, $parents, $table, 'ContentType', we_base_ContentTypes::FOLDER, $db);
						we_readChilds($i, $childs, $table, true, '', 'ContentType', we_base_ContentTypes::FOLDER, $db);
					}
					$childlist = implode(',', $childs);
					$parentlist = implode(',', $parents);

					$wsQuery = ($parentlist ? ' t.ID IN(' . $parentlist . ') ' . ($childlist ? ' OR ' : '') : '') .
							($childlist ? ' t.ParentID IN(' . $childlist . ') ' : '');
				}
			}

			$sqld = g_l('weEditorInfo', '[mysql_date_only_format]');


			$q = 'FROM ' . $db->escape($table) . ' t LEFT JOIN ' . USER_TABLE . ' u1 ON u1.ID=t.CreatorID LEFT JOIN ' . USER_TABLE . ' u2 ON u2.ID=t.ModifierID ' .
					" WHERE (((t.Published=0 OR t.Published<t.ModDate) AND t.ContentType IN ('" . we_base_ContentTypes::WEDOCUMENT . "','" . we_base_ContentTypes::HTML . "','" . we_base_ContentTypes::OBJECT_FILE . "'))" .
					($myWfDocsCSV ? ' OR (t.ID IN(' . $myWfDocsCSV . ')) ' : '') . ')' .
					(isset($wsQuery) ? ' AND (' . $wsQuery . ') ' : '');
			$order = ' ORDER BY ' . ($myWfDocsCSV ? 'mywforder DESC,' : '') . $order;

			$anz = f('SELECT COUNT(1) ' . $q, '', $db);

			$all = $db->getAllq('SELECT ' .
					($wfDocsCSV ? '(t.ID IN(' . $wfDocsCSV . ')) AS wforder,' : '') . ' ' .
					($myWfDocsCSV ? '(t.ID IN(' . $myWfDocsCSV . ')) AS mywforder,' : '') . '
	t.ContentType,
	t.ID,
	t.Text,
	t.ParentID,
	t.Path,
	t.ModDate,
	IF(t.Published>0,FROM_UNIXTIME(t.Published,"' . $sqld . '"),"-") AS Published,
	IF(t.ModDate>0,FROM_UNIXTIME(t.ModDate,"' . $sqld . '"),"-") AS Modified,
	IF(t.CreationDate>0,FROM_UNIXTIME(t.CreationDate,"' . $sqld . '"),"-") AS CreationDate,
	u2.username AS Modifier,
	u1.username AS Creator ' . $q . $order . ' LIMIT ' . intval($offset) . ',' . intval($numRows));
			$content = [];

			foreach($all as $cur){
				$cont[$cur['ModDate']] = $path = '<tr><td class="upbIcon" data-contenttype="' . $cur['ContentType'] . '"></td><td class="upbEntry middlefont ' . ($cur['Published'] != '-' ? 'changed' : "notpublished") . '" onclick="WE().layout.weEditorFrameController.openDocument(\'' . $table . '\',' . $cur['ID'] . ',\'' . $cur['ContentType'] . '\')" title="' . $cur['Path'] . '">' . $cur['Path'] . '</td></tr>';
				$row = [
					['dat' => $path],
				];
				if(we_modules_info::isActive(we_modules_info::WORKFLOW)){
					if(!empty($cur['wforder'])){
						$step = we_workflow_utility::findLastActiveStep($cur['ID'], $table) + 1;
						$steps = count(we_workflow_utility::getNumberOfSteps($cur['ID'], $table));
						$row[] = ['dat' => $step . '&nbsp;' . g_l('exchange','[step_of]') . '&nbsp;' . $steps . '&nbsp;<i class="fa fa-lg fa-circle" style="color:#' . ($cur['mywforder'] ? '006DB8' : 'E7E7E7') . ';"></i>'];
					} else {
						$row[] = ['dat' => '-'];
					}
				}
				$content[] = $row;
			}
		}

		asort($cont);
		$this->ct = '<table class="default">' . implode('', $cont) . '</table>';
	}

	public function getInsertDiv($iCurrId, $aProps, we_base_jsCmd $jsCmd){
		$cfg = self::getDefaultConfig();
		$oTblDiv = we_html_element::div(['id' => "m_" . $iCurrId . "_inline",
					'style' => 'height:' . ($cfg["height"] - 25) . 'px;overflow:auto;'
						], $this->ct);

		$sTb = g_l('cockpit', ($this->bTypeDoc && $this->bTypeObj ? '[upb_docs_and_objs]' : ($this->bTypeDoc ? '[upb_docs]' : ($this->bTypeObj ? '[upb_objs]' : '[upb_docs_and_objs]'))));

		$jsCmd->addCmd('setIconOfDocClass', 'upbIcon');

		return [$oTblDiv, [$sTb, ""]];
	}

	public static function getDefaultConfig(){
		$shortCuts = (we_base_permission::hasPerm(we_base_perm::WORK_DOCUMENTS_CAN_SEE) ? '1' : '0') .
				(we_modules_info::isActive(we_modules_info::OBJECT) && we_base_permission::hasPerm(we_base_perm::OBJECTFILES_CAN_SEE) ? '1' : '0');

		return [
			'width' => self::WIDTH_SMALL,
			'expanded' => 0,
			'height' => 210,
			'res' => 0,
			'cls' => 'lightCyan',
			'csv' => $shortCuts,
			'dlgHeight' => 190,
			'isResizable' => 1
		];
	}

	public static function showDialog(){
		list($jsFile, $oSelCls) = self::getDialogPrefs();

		$oChbxDocs = we_html_forms::checkbox(0, true, "chbx_type", g_l('cockpit', '[documents]'), true, "defaultfont", "", false, "", 0, 0);
		$oChbxObjs = we_html_forms::checkbox(0, true, "chbx_type", g_l('cockpit', '[objects]'), true, "defaultfont", "", false, "", 0, 0);

		$dbTableType = '<table><tr>' .
				'<td>' . $oChbxDocs . ' </td>' .
				(we_modules_info::isActive(we_modules_info::OBJECT) && we_base_permission::hasPerm(we_base_perm::OBJECTFILES_CAN_SEE) ? "<td>" . $oChbxObjs . '</td>' : '') .
				"</tr></table>";

		$parts = [['headline' => g_l('cockpit', '[type]'), 'html' => $dbTableType, 'space' => we_html_multiIconBox::SPACE_MED],
			['headline' => '', 'html' => $oSelCls->getHTML(),],
		];

		$save_button = we_html_button::create_button(we_html_button::SAVE, "javascript:save();");
		$preview_button = we_html_button::create_button(we_html_button::PREVIEW, "javascript:preview();");
		$cancel_button = we_html_button::create_button(we_html_button::CLOSE, "javascript:exit_close();");
		$buttons = we_html_button::position_yes_no_cancel($save_button, $preview_button, $cancel_button);

		$sTblWidget = we_html_multiIconBox::getHTML('mfdProps', $parts, true, $buttons, -1, "", "", "", g_l('cockpit', '[unpublished]'));

		echo we_html_tools::getHtmlTop(g_l('cockpit', '[unpublished]'), '', '', $jsFile .
				we_html_element::jsScript(JS_DIR . 'widgets/upb.js')
				, we_html_element::body(
						['class' => 'weDialogBody', 'onload' => "init();"], we_html_element::form([], $sTblWidget)));
	}

	public function showPreview(){
		$jsCmd = new we_base_jsCmd();
		$jsCmd->addCmd('initPreview', [
			'id' => we_base_request::_(we_base_request::STRING, 'we_cmd', '', 5),
			'type' => 'upb',
			'tb' => g_l('cockpit', ($this->bTypeDoc && $this->bTypeObj ? '[upb_docs_and_objs]' : ($this->bTypeDoc ? '[upb_docs]' : ($this->bTypeObj ? '[upb_objs]' : '[upb_docs_and_objs]')))),
		]);
		$jsCmd->addCmd('setIconOfDocClass', 'upbIcon');

		echo we_html_tools::getHtmlTop(g_l('cockpit', '[unpublished]'), '', '', $jsCmd->getCmds(), we_html_element::body(['style' => 'margin:10px 15px;',
						], we_html_element::div(['id' => "upb"
								], $this->ct)));
	}

}
